#include "asm.h"
#include "coroutine.h"

	@------------------------------------------------
	@ void co_call(coroutine_t co);
	@------------------------------------------------
ARM_ENTRY(co_call)
	stmfd	sp!, {r4-r12,lr}
	ldr	r1, =sp_caller
	ldr	r2, =sp_co
	ldr	r3, =co_pool
	str	sp, [r1]				@ ݂spޔ
	str	r0, [r3]				@ cõAhXۑ
	ldr	r3, [r0]				@ Wv
	add	r1, r0, #8
	add	r0, r0, #4
	ldr	r0, [r0]				@  co->data Ă
	str	r1, [r2]				@ &co->sp ޔ
	ldr	sp, [r1]
	ldmfd	sp!, {r4-r12,lr}
	bx	r3

	@------------------------------------------------
	@ void co_resume_to(void (*func)(void*));
	@------------------------------------------------
ARM_ENTRY(co_resume_to)
	mov	lr, r0
	ldr	r1, =sp_co
	ldr	r1, [r1]

	sub	r1, r1, #8				@ WvĂKv͖
	str	r0, [r1]				@ gdb  co Ƃ̂߂ɎcĂ

	add	r1, r1, #(12 + CO_STACK_SIZE)
	mov	sp, r1					@ X^bN߂
							@ ̂܂ co_resume ɓ

	@------------------------------------------------
	@ void co_resume(void);
	@------------------------------------------------
ARM_ENTRY(co_resume)
	stmfd	sp!, {r4-r12,lr}
	ldr	r1, =sp_caller
	ldr	r2, =sp_co
	ldr	r3, =co_pool
	ldr	r3, [r3]
	str	lr, [r3]
	ldr	r2, [r2]
	str	sp, [r2]
	ldr	sp, [r1]
	ldmfd	sp!, {r4-r12,lr}
	mov	r0, #0
	bx	lr

	@------------------------------------------------
	@ void co_exit(void);
	@------------------------------------------------
THUMB_ENTRY(co_exit_thumb)
	ldr	r1, =co_exit
	bx	r1

ARM_ENTRY(co_exit)
	stmfd	sp!, {r4-r12,lr}
	ldr	r1, =sp_caller
	ldr	r2, =sp_co
	ldr	r3, =co_pool
	ldr	r4, =co_exit
	ldr	r3, [r3]
	str	r4, [r3]
	ldr	r2, [r2]
	str	sp, [r2]
	ldr	sp, [r1]
	ldmfd	sp!, {r4-r12,lr}
	mov	r0, #1
	bx	lr

LOCAL_ENTRY(sp_caller)
	.word	0
LOCAL_ENTRY(sp_co)
	.word	0
LOCAL_ENTRY(co_pool)
	.word	0
